#include "StdAfx.h"
#include ".\tools.h"

// Split a line following delim. Here delim is a single char
// Works with collapsed delimiter, part1\t\tpart2 would return tree elements, part1, empty and part2
int	 Tools::Split(char delim, std::string &value, std::vector<std::string> &result)
{
	result.clear();
	const char *ptBeg, *ptEnd, *data = value.c_str();
	ptBeg = ptEnd = data;
	while (*ptEnd!=0)
	{
		while (*ptEnd!=delim && *ptEnd!=0)
			ptEnd++;

		std::string temp;
		temp.append(ptBeg, ptEnd-ptBeg);
		result.push_back(temp);
		if (*ptEnd==delim)
			ptEnd++;
		ptBeg = ptEnd;
	}	
	return (int)result.size();
}

// Remove space at the beginning and the end
void Tools::Trim (std::string &value)
{
	bool bFound=true;
	std::string::size_type size = value.size();
	if (value.find_first_not_of(" ")!=std::string::npos)
	{
		while (bFound)
		{
			std::string::size_type begin = value.find_first_not_of(" ");
			std::string::size_type end = value.find_last_not_of(" ")+1;
			if (end-begin!=size && begin!=std::string::npos && end!=std::string::npos)
			{
				value = value.substr(begin, end-begin);
				size = end-begin;
			}
			else
				bFound=false;
		}
	}
	else
		value.clear();
}
