/*
	UScanIT project
	Virus scanner
	Eric POMMEREUIL, Rmi THOMAS, May 2004, remi@xtware.com
*/

#include "StdAfx.h"
#include ".\clamscanner.h"
#include "..\ZipLib\unzip.h"
#include <time.h>

double nComp = 0;
int nArrays;
int nNodes;
int nSuperNodes;
int nFound;
int nInit;
int nMulti;

#ifdef OLD_VERSION
//##########################################################################
//                              OLD ENGINE
//##########################################################################
clam::clamNode::clamNode(clam::clamSignature *pSig, int part) : pSig(pSig), next(NULL)
{
	this->size = pSig->m_data[part]->GetSize();
	this->sig = (short *)pSig->m_data[part]->GetData();
	this->nPart = (pSig->m_data.GetSize() > 1) ? part+1 : part;
}
clam::clamNode::~clamNode()
{
}

clam::clamTree::clamTree()
{ 
	// Nodes array
	m_pRoot = new clamNode **[256];
	// Init array
	for(int i = 0; i < 256; i++) 
		m_pRoot[i] = NULL; 
}
clam::clamTree::~clamTree()	
{ 
	if (m_pRoot != NULL) 
	{
		for(int i = 0; i < 256; i++)
		{
			if (m_pRoot[i] != NULL)
			{
				for(int j = 0; j < 256; j++)
				{
					clamNode *node = m_pRoot[i][j];
					while(node != NULL)
					{
						clamNode *next = node->next;
						delete node;
						node = next;
					}
				}
				delete []m_pRoot[i];
			}
		}
		delete []m_pRoot; 
	}
}
bool clam::clamTree::AddVirusSignature (ClassLinkList2<clamSignature> *in)
{	
	clamSignature *sig = in->GetFirst();
	while(sig != NULL)
	{
		for(int part = 0; part < sig->m_data.GetSize(); part++)
		{
			clamNode *node = new clamNode(sig, part);
			short *data = node->sig;

			if (m_pRoot[*data] == NULL)
			{
				// Create Array
				m_pRoot[*data] = new clamNode *[256];
				// Init Array
				for(int i = 0; i < 256; i++)
					m_pRoot[*data][i] = NULL;
				
				// Insert first node
				m_pRoot[*data][data[1]] = node;
				
			} else
			{
				clamNode **pArray = m_pRoot[*data];
				// Insert
				if (pArray[data[1]] == NULL)
					pArray[data[1]] = node;
				else
				{
					// Insert node in pole position
					node->next = pArray[data[1]];
					pArray[data[1]] = node;
				}		
			}
		}
		sig = in->GetNext();
	}

	//for(int i = 0; i < 256; i++)
	//{
	//	printf("%3d : ",i);
	//	if (m_pRoot[i] != NULL)
	//	{
	//		for(int j = 0; j < 256; j++)
	//		{
	//			if (m_pRoot[i][j] != NULL)
	//			{
	//				clamNode *node = m_pRoot[i][j];
	//				int n = 0;
	//				while(node)
	//				{
	//					n++;
	//					node = node->next;
	//				}
	//				printf("%3d ",n);
	//			} else
	//				printf("  0 ");
	//		}
	//		printf("\n");
	//	} else
	//		printf("NULL\n");
	//}

	return false;
}

void clam::clamScanner::ResetScan()
{
	clamNode ***root = m_pTree->GetRootNode();
	if (root != NULL) 
	{
		for(int i = 0; i < 256; i++)
		{
			if (root[i] != NULL)
			{
				for(int j = 0; j < 256; j++)
				{
					clamNode *node = root[i][j];
					while(node != NULL)
					{
						node->pSig->idDocument = -1;
						node->pSig->magicCode = (1 << node->pSig->m_data.GetSize())-1;
						node = node->next;
					}
				}
			}
		}
	}
	idDocument=-1;
}

clam::clamSignature *clam::clamScanner::ScanBuffer(unsigned char *buf, int size)
{
	clam::clamNode ***root = m_pTree->GetRootNode();

	if (size < 2)
		return NULL;

	int sizeToScan = size-2;
	for(int i = 0; i < size; i++, buf++, sizeToScan--)
	{
		if (root[*buf] != NULL)
		{
			clam::clamNode *node = root[*buf][buf[1]];
			while(node)
			{
				//int sizeSig = node->realSize;
				//unsigned char *sig = node->sig + 2;
				int sizeSig = node->size / 2;
				short *sig = node->sig + 2;
				if (sizeToScan >= sizeSig)
				{
					for(int j = 2; j < sizeSig ; j++, sig++)
					{
						nComp++;
						if (*sig != 256 && *sig != buf[j])
							goto NextSignature;
					}
//					nComp+=j-1;
					 //Virus found
					if (j == sizeSig)
					{
						nFound++;
//						nComp--;
						if (node->nPart == 0)
							return node->pSig;
						else
						{	// Multi-parts
							clam::clamSignature *s = node->pSig;
							// New document
							if (idDocument != s->idDocument)
							{
								// Initialization
								s->idDocument = idDocument;
								s->magicCode = (1 << s->m_data.GetSize())-1;
							}
							// Set bit to zero
							s->magicCode &= ~(1 << (node->nPart-1));
							// magicCode == 0 if all parts found
							if (s->magicCode == 0)
								return node->pSig;
						}
					}
				}
NextSignature:
				node = node->next;
			}
		}
	}

	return NULL;
}
#else		
//##########################################################################
//                              NEW ENGINE
//##########################################################################

clam::clamSuperNode::clamSuperNode() : array(NULL), count(0), list(NULL)
{
	nSuperNodes++;
}

clam::clamSuperNode::clamSuperNode(bool bArray) : count(0), list(NULL)
{
	nSuperNodes++;
	if (bArray)
	{
		array = new clamSuperNode*[257];
		memset(array,0,sizeof(clamSuperNode*)*257);
		nArrays++;
	} else
		array = NULL;
}

clam::clamSuperNode::~clamSuperNode()
{
	if (array != NULL)
	{
		for(int i = 0; i < 256; i++)
			if (array[i])
				delete array[i];
		delete []array;
	} else
	{
		clamNode *node = list;
		clamNode *next;
		while(node)
		{
			next = node->next;
			delete node;
			node = next;
		}
	}	
}
void clam::clamSuperNode::Reset()
{
	if (array != NULL)
	{
		for(int i = 0; i < 256; i++)
			if (array[i])
				array[i]->Reset();
	} else
	{
		clamNode *node = list;
		while(node)
		{
			node->pSig->idDocument = -1;
//			node->pSig->magicCode = (1 << node->pSig->m_data.GetSize())-1;
			node = node->next;
		}
	}
}

void clam::clamSuperNode::LinkedList2Array()
{
	// Alloc array
	array = new clamSuperNode*[257];
	memset(array,0,sizeof(clamSuperNode *)*257);
	nArrays++;

	clamNode *node = list;
	clamNode *prev = NULL;
	while(node)
	{
		if (node->size > 1)
		{
			if (prev == NULL)	list = node->next;
			else				prev->next = node->next;

			int val = node->data[0];

			if (array[val] == NULL)
				array[val] = new clamSuperNode();

			node->next = array[val]->list;
			node->data++;
			node->size--;
			array[val]->list = node;
			array[val]->count++;

			node = (prev) ? prev->next : list;

			count--;
		} else
		{
			prev = node;
			node = node->next;
		}
	}
}

void clam::clamSuperNode::InsertSignature(clamSignature *sig, int part, short *pData)
{
	short *data = (short *)sig->m_data[part]->GetData();
	int size = sig->m_data[part]->GetSize() / 2;

	__int64 sizeToInsert = (data + size) - pData;
	if (sizeToInsert == 0)
		return;

	if (array != NULL && sizeToInsert > 1)
	{ // Array		
		int val = *pData++;
		if (array[val] == NULL)
			array[val] = new clamSuperNode();
		array[val]->InsertSignature(sig,part,pData);
	} else
	{ // Linked list
		clamNode *node = new clamNode(sig,part);
		node->size = (node->data + node->size)-pData;
		node->data = pData;
		node->next = list;
		list = node;
		count++;
		if (count > 2)
			LinkedList2Array();
	}
}

clam::clamSignature *clam::clamSuperNode::SearchSignature(int idDocument, unsigned char *buf, int size, int iBuf, int iSig)
{
	if (iBuf == size)
		return NULL;
	
	if (list != NULL)
	{
		int sizeToScan = size-iBuf;
		clam::clamNode *node = list;
		while(node)
		{
			__int64 sizeSig = node->size;
			short *data = node->data;
			if (sizeToScan >= node->size)
			{
				unsigned char *pBuf = buf + iBuf;
				for(int i = 0; i < node->size; i++, data++)
				{
//					nComp++;
					if (*data != 256 && *data != pBuf[i])
						goto NextSignature;
				}
				// Virus found
				if (node->nPart == 0)
					return node->pSig;
				else
				{	
					// Multi-parts
					clam::clamSignature *s = node->pSig;
					// New document
					if (idDocument != s->idDocument)
					{
						// Initialization
						s->idDocument = idDocument;
						s->magicCode = (1 << s->m_data.GetSize())-1;
					}
					// Set bit to zero
					s->magicCode &= ~(1 << (node->nPart-1));
					// magicCode == 0 if all parts found
					if (s->magicCode == 0)
						return node->pSig;
				}
			}
NextSignature:
			node = node->next;
		}
	}

	if (array != NULL)
	{
		clam::clamSignature *s;

		clam::clamSuperNode *pSN = array[buf[iBuf]];
		if (pSN)
		{
			s = pSN->SearchSignature(idDocument,buf,size,iBuf+1,iSig+1);
			if (s)
				return s;
		}

		if (array[256])
		{
			s = array[256]->SearchSignature(idDocument,buf,size,iBuf+1,iSig+1);
			if (s)
				return s;
		}
	} 
	return NULL;
}


clam::clamNode::clamNode() : pSig(NULL), next(NULL)
{
}
clam::clamNode::clamNode(clam::clamSignature *pSig, int part) : pSig(pSig), next(NULL)
{
	nNodes++;
	this->size = pSig->m_data[part]->GetSize() / 2;
	this->data = (short *)pSig->m_data[part]->GetData();
	this->nPart = (pSig->m_data.GetSize() > 1) ? part+1 : part;
}

clam::clamNode::~clamNode()
{
}

clam::clamTree::clamTree()
{ 
	m_pRoot = new clamSuperNode(true);
}

clam::clamTree::~clamTree()	
{
	if (m_pRoot)
		delete m_pRoot;
}



bool clam::clamTree::AddVirusSignature (ClassLinkList2<clamSignature> *in)
{	
	clamSignature *sig = in->GetFirst();
	int i = 0;
	while(sig != NULL)
	{
		for(int part = 0; part < sig->m_data.GetSize(); part++)
			m_pRoot->InsertSignature(sig,part,(short *)sig->m_data[part]->GetData());
		i++;
		//printf("%5d : Mem = %d, Arrays = %d, SuperNodes = %d, Nodes = %d\n", i,
		//	nArrays*sizeof(clamSuperNode *)*257 + nSuperNodes * sizeof(clamSuperNode) + nNodes * sizeof(clamNode),
		//	nArrays,nSuperNodes,nNodes);
		sig = in->GetNext();
	}
	return false;
}

void clam::clamScanner::ResetScan()
{
	m_pTree->GetRootNode()->Reset();
	idDocument=-1;
}
clam::clamSignature *clam::clamScanner::ScanBuffer(unsigned char *buf, int size)
{
	clam::clamSuperNode *sn = m_pTree->GetRootNode();

	if (size < 2)
		return NULL;
	
	for(int i = 0; i < size; i++)
	{
		clam::clamSuperNode *pSN = sn->array[buf[i]];
		if (pSN)
		{
			clam::clamSignature *s = pSN->SearchSignature(idDocument,buf,size,i+1,1);
			if (s)
				return s;
		}
		//clam::clamSignature *s = sn->SearchSignature(idDocument,buf,size,i,0);
		//if (s)
		//	return s;
	}
	return NULL;
}
#endif

void clam::clamScanner::Init (clamTree *pTree)
{
	if (m_pBuffer == NULL)
		m_pBuffer = new unsigned char[20480];
	m_pTree = pTree;
}

bool clam::clamScanner::BeginMemoryScan	(pixtek::tools::ClassStream *in, int maxScanSize, clamSignature **signature)
{

	// For multi-parts, tell it's a new document
	idDocument++;

	if (in != NULL)
		in->Read(m_pBuffer+10240,maxScanSize);
	// Si maxScanSize < 10240 a veut dire qu'il n'y aura pas d'appel  NextMemoryScan 
	if (maxScanSize < 10240)
	{
		*signature = ScanBuffer(m_pBuffer+10240,maxScanSize);
		if (*signature)
			return false;
	}
	return true;
}

bool clam::clamScanner::NextMemoryScan (pixtek::tools::ClassStream *in, int maxScanSize, clamSignature **signature)
{
	memcpy(m_pBuffer,m_pBuffer+10240,10240);
	if (in != NULL)
		in->Read(m_pBuffer+10240,maxScanSize);
	// Si maxScanSize < 10240 a veut dire qu'il n'y aura pas d'appel  NextMemoryScan 
	if (maxScanSize < 10240)
		*signature = ScanBuffer(m_pBuffer,maxScanSize+10240);
	else
		*signature = ScanBuffer(m_pBuffer,maxScanSize);
	return (*signature == 0);
}

bool clam::clamFileScanner::ScanDirectory (const char *baseDirectory, const char *filter, bool *bExit, fileStat *pStat, bool recursive)
{
	WIN32_FIND_DATA	findData;
	CStr path;
	path.Format("%s\\%s", baseDirectory, filter);
	bool bError=false;

	HANDLE hFind = FindFirstFile(path.SafeGet(), &findData);
	if (hFind!=INVALID_HANDLE_VALUE)
	{
		do
		{
			CStr path2;
			path2.Format("%s\\%s", baseDirectory, findData.cFileName);

			if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				if (recursive && _tcscmp(findData.cFileName, TEXT(".")) && _tcscmp(findData.cFileName, TEXT("..")))
				{
					pStat->m_numberOfDirectory++;
					ScanDirectory(path2.SafeGet(), filter, bExit, pStat, recursive);
				}
			}
			else
				ScanFile(path2.SafeGet(), bExit, pStat);
		}
		while (FindNextFile(hFind, &findData) && !*bExit);
		FindClose(hFind);
	}
	else
		bError=true;

	DirectoryScannedEvent(baseDirectory);
	_UpdateStat(pStat);

	return (pStat->m_numberOfPositivesFile>0 || bError);
}

clam::fileError clam::clamFileScanner::ScanFileZip (const char *fileName, bool *bExit, fileStat *pStat)
{
	clam::fileError result;

	unzFile uf = unzOpen(fileName);
	if (uf != NULL)
	{
		unz_global_info gi;
		int err = unzGetGlobalInfo (uf,&gi);
		
		for (unsigned int i = 0; i < gi.number_entry; i++)
		{
			unz_file_info file_info;
			char filename_inzip[MAX_PATH];
			char name[MAX_PATH];
			int err = unzGetCurrentFileInfo(uf,&file_info,filename_inzip,sizeof(filename_inzip),NULL,0,NULL,0);
			if (err == UNZ_OK)
			{
				char *s1 = strrchr(filename_inzip,'\\');
				char *s2 = strrchr(filename_inzip,'/');

				// File detection (not directory)
				if ((s1 == NULL || s1[1] != '\0') && (s2 == NULL || s2[1] != '\0'))
				{
					sprintf(name,"%s [%s]",fileName,filename_inzip);
					err = unzOpenCurrentFilePassword(uf,NULL);
					if (err == UNZ_OK)
					{
						char *ext = strrchr(filename_inzip,'.');
						if (ext && (!stricmp(ext,".zip") || !stricmp(ext,".gz")))
						{
							// un id comme un autre pour diffrencier les fichiers zip temporaires lors de la rcursivit
							clock_t id = clock();	
							char tmpName[MAX_PATH];
							sprintf(tmpName,"c:\\uscanit%d.zip",id);
							// Extract in temporary file
							FILE *fTmp = fopen(tmpName,"wb");
							if (fTmp)
							{
								int status;
								do
								{
									status = unzReadCurrentFile(uf,m_pBuffer,20480);			
									if (status > 0)
										fwrite(m_pBuffer,status,1,fTmp);
								} while(status > 0);
								fclose(fTmp);
								if (status == 0)
								{
									// Scan temporary file
									fileError err = ScanFileZip(tmpName, bExit, pStat);
									// Delete temporary file
									BOOL bStatus = DeleteFile(tmpName);
									//if (bStatus == 0)
									//	MessageBox(NULL,tmpName,"DeleteFile Error",MB_OK);
								}
							}
						} else
						{							
							// Extract file into memory
							clamSignature *pVirus = NULL;							
							bool bContinue = true;
							bool bFirst = true;
							int status;
							do
							{
								if (bFirst)
									status = unzReadCurrentFile(uf,m_pBuffer+10240,10240);			
								else
									status = unzReadCurrentFile(uf,m_pBuffer,10240);			
								if (status > 0)
								{
									if (bFirst)
									{
										bContinue = BeginMemoryScan(NULL,status,&pVirus);
										bFirst = false;
									} else
										bContinue = NextMemoryScan(NULL,status,&pVirus);
									pStat->m_volume += status;
									_UpdateStat(pStat);

									if (!bContinue)
									{
										pStat->m_numberOfPositivesFile++;									
										FileVirusEvent(name, pVirus);
										result = ERR_VIRUS;
										break;
									}
								} 
							} while (status > 0 && !*bExit);
							if (status == 0)
							{
								pStat->m_numberOfFile++;
								FileScannedEvent(name);
							} else if (status < 0)
							{
								pStat->m_numberOfError++;
								FileErrorEvent(name, ERR_ZIP_EXTRACT);
							}
						} 
						unzCloseCurrentFile(uf); 
					}
					else
					{
							result = ERR_ZIP_OPEN;
							pStat->m_numberOfError++;
							FileErrorEvent(name, result);
					}
				}
			} else
			{
				pStat->m_numberOfError++;
				FileErrorEvent(fileName, ERR_ZIP_FILE);
			}

			if ((i+1) < gi.number_entry)
			{
				err = unzGoToNextFile(uf);
				if (err != UNZ_OK)
				{
					pStat->m_numberOfError++;
					FileErrorEvent(fileName, ERR_ZIP_FILE);
					break;
				}
			}
		}

		unzClose(uf);

		result = ERR_SUCCESS;
		pStat->m_numberOfFile++;
		FileScannedEvent(fileName);
	} else
	{
		result = ERR_ACCESSDENIED;
		pStat->m_numberOfError++;
		FileErrorEvent(fileName, result);
	}

	return result;
}

clam::fileError clam::clamFileScanner::ScanFile (const char *fileName, bool *bExit, fileStat *pStat)
{
	clam::fileError result;

	char *ext = strrchr(fileName,'.');
	if (ext != NULL)
		if (!stricmp(ext,".zip") || !stricmp(ext,".gz"))
			return ScanFileZip(fileName,bExit,pStat);

	pixtek::tools::FileStreamRead fsr;
	if (fsr.Open(fileName))
	{
		int size = fsr.Size();
		clamSignature *pVirus=0;
		int realSize = min(10240, size);
		bool bContinue = BeginMemoryScan(&fsr, realSize, &pVirus);
		pStat->m_volume+=realSize;
		size -= realSize;
		while (size>0 && bContinue && !*bExit)
		{
			realSize = min(10240, size);
			bContinue = NextMemoryScan(&fsr, realSize, &pVirus);
			pStat->m_volume+=realSize;
			size -= realSize;
			_UpdateStat(pStat);
		}

		fsr.Close();

		if (bContinue)
		{
			pStat->m_numberOfFile++;
			FileScannedEvent(fileName);
			result=ERR_SUCCESS;
		}
		else
		{
			pStat->m_numberOfPositivesFile++;
			FileVirusEvent(fileName, pVirus);
			result=ERR_VIRUS;
		}
	}
	else
	{
		DWORD error = GetLastError();
		switch (error)
		{
		case 5:	// Access denied
		case 32: // File locked
			result = ERR_ACCESSDENIED;
			break;
		case 1006: // Empty file (size=0) on MapViewOfFile
			result = ERR_SUCCESS;
			break;
		default:
			result = ERR_UNKNOWN;
			break;
		}

		if (result!=ERR_SUCCESS)	
		{
			pStat->m_numberOfError++;
			FileErrorEvent(fileName, result);
		}
	}

	return result;
}

void clam::clamFileScanner::_UpdateStat(fileStat *pStat)
{
	m_statIdx++;
	if (m_statIdx==m_granularity)
	{
		UpdateStatEvent(pStat);
		m_statIdx=0;
	}
}
