/*
	UScanIT project
	Virus scanner
	Eric POMMEREUIL, Rmi THOMAS, May 2004, remi@xtware.com
*/
#pragma once

#include "clamDB.h"

//#define OLD_VERSION

namespace clam
{
#ifdef OLD_VERSION
//##########################################################################
//                              OLD ENGINE
//##########################################################################
	class clamNode
	{
	public:
		int						nPart;
		int						size;
		int						realSize;
		short					*sig;
		clamNode *				next;	// Next node
		clam::clamSignature *	pSig;	// Signature
	public:
		clamNode	(clam::clamSignature *pSig, int part);
		~clamNode	();
	};

	class clamTree
	{
		clamNode ***m_pRoot;
	public:

				clamTree();
		virtual ~clamTree();
		bool			AddVirusSignature	(ClassLinkList2<clamSignature> *in);
		clamNode ***	GetRootNode			() { return m_pRoot; }
	};
#else
//##########################################################################
//                              NEW ENGINE
//##########################################################################
	class clamNode
	{
	public:
		int						nPart;
		__int64					size;
		short *					data;
		clamNode *				next;
		clam::clamSignature *	pSig;	// Signature
	public:
		clamNode	();
		clamNode	(clam::clamSignature *pSig, int part);
		~clamNode	();
	};

	class clamSuperNode
	{
		void			LinkedList2Array();
	public:
		clamSuperNode **	array;	
		int					count;
		clamNode *			list;	

		clamSuperNode	();
		clamSuperNode	(bool bArray);
		~clamSuperNode	();

		void			Reset			();
		void			InsertSignature	(clamSignature *sig, int part, short *pData);
		clamSignature *	SearchSignature	(int idDocument, unsigned char *buf, int size, int iBuf, int iSig);
	};

	class clamTree
	{
		clamSuperNode *m_pRoot;
	public:

				clamTree	();
		virtual ~clamTree	();
		bool			AddVirusSignature	(ClassLinkList2<clamSignature> *in);
		clamSuperNode *	GetRootNode			() { return m_pRoot; }
	};

#endif

	class clamScanner
	{
	protected:
		unsigned char *	m_pBuffer;
	private:
		clamTree *		m_pTree;
		int				idDocument;		// used for multi-parts
		
		clam::clamSignature *	ScanBuffer	(unsigned char *buf, int size);
	public:
		clamScanner () 			{  m_pBuffer=0; }
		virtual ~clamScanner () { if (m_pBuffer) delete m_pBuffer; }

				void	Init				(clamTree *pTree);
				// Generic scanning
				// maxScanSize = number of byte read from stream. If -1 then go to the end of stream
				// outSignature = signature info if BeginMemory returns false
				void	ResetScan			();	// reset multi-parts engine
				bool	BeginMemoryScan		(pixtek::tools::ClassStream *in, int maxScanSize, clamSignature **outSignature);
				bool	NextMemoryScan		(pixtek::tools::ClassStream *in, int maxScanSize, clamSignature **outSignature);
	};

	struct fileStat
	{
		fileStat() { Reset(); }
		void	Reset() { m_numberOfFile=0; m_numberOfPositivesFile=0; m_numberOfError=0; m_volume=0; m_numberOfDirectory=0; }
		int		m_numberOfFile;
		int		m_numberOfPositivesFile;
		int		m_numberOfDirectory;
		int		m_numberOfError;
		__int64	m_volume;
	};

	enum fileError { ERR_SUCCESS=0, ERR_VIRUS=1, ERR_ACCESSDENIED=2, ERR_UNKNOWN=3, ERR_ZIP_OPEN, ERR_ZIP_EXTRACT, ERR_ZIP_FILE};

	class clamFileScanner : public clamScanner
	{
		int		m_granularity;
		int		m_statIdx;
		void	_UpdateStat(fileStat *pStat);

	protected:
		fileError	ScanFileZip	(const char *fileName, bool *bExit, fileStat *pStat);
	public:
		clamFileScanner()	{ m_granularity=100; m_statIdx=0; }

		void		SetStatGranularity	(int granularity)	{ m_granularity=granularity; }
			// File scanning
				bool		ScanDirectory		(const char *baseDirectory, const char *filter, bool *bExit, fileStat *pStat, bool recursive=false);
				fileError	ScanFile			(const char *fileName, bool *bExit, fileStat *pStat);
			// File event
		virtual	void		FileVirusEvent		(const char *fileName, clamSignature *signature) { } ;
		virtual void		FileScannedEvent	(const char *fileName) {} ;
		virtual void		DirectoryScannedEvent	(const char *baseDirectory) {} ;
		virtual void		FileErrorEvent		(const char *fileName, fileError error) {} ;
		virtual void		UpdateStatEvent		(fileStat *pStat) {} ;
	};

};